#include "otabrowse5.h"
#pragma hdrstop

#include "watcherservices.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TWatcherServicesForm *WatcherServicesForm;
//---------------------------------------------------------------------------

TWatcherServicesForm *f;
void __fastcall OnExists(TPropertyEditor *pe)
{ if (f==NULL) return;
  TPersistent *p=pe->GetComponent(0);
  TComponent *com=dynamic_cast<TComponent*>(p);
  TComponent *own=NULL; if (com!=NULL) own=com->Owner;
  AnsiString s="";
  if (own!=NULL) s=s+own->Name+".";
  if (com!=NULL) s=s+com->Name;
  s=s+" : "+pe->GetName();
  f->mProps->Lines->Add(s);
}


__fastcall TWatcherServicesForm::TWatcherServicesForm(TComponent* Owner)
        : TForm(Owner)
{ f=this;
  NameNotification("*",&OnGeneralForm); // will match every single name
  NameNotification("*.*",&OnGeneralComponent); // will match every component
  RegisterPropertyWatcher(NULL,0,"Caption",::OnExists);
  WatchNotification(wsDebug,OnDebug);
}
__fastcall TWatcherServicesForm::~TWatcherServicesForm()
{ f=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TWatcherServicesForm::OnDebug(_di_IOTAProject p,_di_IOTAModule m,_di_IOTAFormEditor fe,_di_IOTAComponent c,AnsiString name,AnsiString oldname,TWatchAction wa,TWatchSubject ws)
{ AnsiString s="???";
  if (wa==waCreate) s="debugger started";
  if (wa==waDestroy) s="debugger finished";
  mDebug->Lines->Add(s);
}
//---------------------------------------------------------------------------
void __fastcall TWatcherServicesForm::OnGeneralForm(_di_IOTAProject p,_di_IOTAModule m,_di_IOTAFormEditor fe,_di_IOTAComponent c,AnsiString name,AnsiString oldname,TWatchAction wa,TWatchSubject ws)
{ mGeneral->Lines->Add(oldname+" -> "+name);
}
void __fastcall TWatcherServicesForm::OnGeneralComponent(_di_IOTAProject p,_di_IOTAModule m,_di_IOTAFormEditor fe,_di_IOTAComponent c,AnsiString name,AnsiString oldname,TWatchAction wa,TWatchSubject ws)
{ mGeneral->Lines->Add(oldname+" -> "+name);
}
//---------------------------------------------------------------------------
void __fastcall TWatcherServicesForm::OnSpecific(_di_IOTAProject p,_di_IOTAModule m,_di_IOTAFormEditor fe,_di_IOTAComponent c,AnsiString name,AnsiString oldname,TWatchAction wa,TWatchSubject ws)
{ mSpecific->Lines->Add(oldname+" -> "+name);
}
//---------------------------------------------------------------------------

void __fastcall TWatcherServicesForm::bSpecificClick(TObject *Sender)
{ mSpecific->Clear();
  _di_IOTAProject p=GetCurrentProject();
  AnsiString fn=""; if (p!=NULL) fn=p->GetFileName();
  NameNotification(eSpecific->Text,&OnSpecific); // watching for that component
  NameNotification("<project>"+fn,&OnSpecific); // but only in this project
  mSpecific->Lines->Add("Watching "+eSpecific->Text+" in proj '"+ExtractFileName(fn)+"' ...");
}
//---------------------------------------------------------------------------
void __fastcall TWatcherServicesForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{ Action=caFree;
}
//---------------------------------------------------------------------------

void __fastcall TWatcherServicesForm::mGeneralDblClick(TObject *Sender)
{ mGeneral->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TWatcherServicesForm::mSpecificDblClick(TObject *Sender)
{ mSpecific->Clear();
}

//---------------------------------------------------------------------------
void __fastcall TWatcherServicesForm::mPropsDblClick(TObject *Sender)
{ mProps->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TWatcherServicesForm::mDebugDblClick(TObject *Sender)
{ mDebug->Clear();
}
//---------------------------------------------------------------------------

